<?php
/*
Plugin Name: Secundum Link Loja
Plugin URI: http://secundum.com.br
Description: Esse &eacute; o plugin que gera links para sua loja virtual baseado no texto de seu post. Foi desenvolvido para linkar produtos para loja virtual Superloja, informaes em &lt;a href=&quot;http://tenhasualoja.secundum.com.br&quot;&gt;tenhasualoja.secundum.com.br&lt;/a&gt;. Agradecimento especial ao Diego Alves do &lt;a href=&quot;http://www.conexaovip.com/blog/&quot;&gt;conexaovip&lt;/a&gt; pela pacincia de servir de cobaia de testes.
Author: Jobson Lemos, Janio Sarmento e Luiz Gadetto
Version: 1.3
Author URI:
*/

$url_loja = "http://urldaloja/";

$artigos_sec = Array("o","a","um","uma","do","da","no","na","esse","essa","este","esta","seu","sua","meu","minha","nosso","modelo","marca");

$inuteis_sec = Array("ou","semana","feira","segunda","ter&ccedil;a","terca","quarta","quinta","sexta","s&aacute;bado","sabado","domingo",
                     "m&ecirc;s","mes","meses","janeiro","fevereiro","mar&ccedil;o","marco","abril","maio","junho","julho","agosto",
                     "setembro","outubro","novembro","dezembro","ano","anos","novo","nova","novos","novas","foi","que","quando","quem",
                     "para","por","nao","n&atildeo;","eu","voce","voc&ecirc;","mais","menos","melhor","pior","melhores","piores",
                       "principal","principais","maior","menor","maiores","menores","pouco","muito","poucos","poucas","excelente",
                       "excelentes","otimo","otima","otimos","otimas","&oacute;timo","&oacute;tima","&oacute;timos","&oacute;timas","grande",
                       "grandes","pequeno","pequena","pequenos","pequenas","dia","noite","dias","noites","vez","clareza","loja","lojas",
                       "comunidade","comunidades","outro","outra","outros","outras","blog","blogueiro","blogs","blogueiros","site","sites",
                       "mesmo","mesma","mesmos","mesmas","fim","link","feed","feeds","rss","dificuldade","dificuldades","facilidade",
                       "facilidades","momento","nota","se","ambos","ambas","intuito","e","era","forte","fortes","fraco","fracos","tudo",
                       "todo","toda","todos","todas","vai","alto","alta","os","as","uns","umas","dos","das","nos","nas","esses","essas",
                       "estes","estas","nesses","nessas","nestes","nestas","aqueles","aquelas","daqueles","daquelas","naqueles","naquelas",
                       "destes","destas","desses","dessas","seus","suas","meus","minhas","nossos","isso","monte","montes","enorme","enormes",
                       "texto","internet","web","tempo","hora","minuto","segundo","final","significado","significativo","tema","amigo",
                       "amiga","parceria","etapa","dentro","fora","primeira","primeiro","segundo","terceira","terceiro","quarto","quinto",
                       "sexto","teu","tua","modo","cima","menu","uso","usa","estupro","estuprador","resto","resta","vida","morte","morto",
                       "morta","bom","boa","parte","escolha","escolho","amplo","ampla","tipo","caso","casa","mundo","surpresa");

$inuteis_user = '';

add_option('SecLinks_URL', $url_loja);
add_option('SecLinks_Inuteis', $inuteis_user);
add_option('SecLinks_CSSClass', '');

$url_loja = stripslashes(get_option('SecLinks_URL'));
$inuteis_user = stripslashes(get_option('SecLinks_Inuteis'));
$css_class = stripslashes(get_option('SecLinks_CSSClass'));

function SecLink_SubPanel() {
    global $url_loja, $artigos_sec, $inuteis_sec, $inuteis_user, $css_class;
    if (isset($_POST['info_update']))
    {
        update_option('SecLinks_URL', stripslashes(trim($_POST['SecLinks_URL'])));
        update_option('SecLinks_Inuteis', stripslashes(trim($_POST['SecLinks_Inuteis'])));
        update_option('SecLinks_CSSClass', stripslashes(trim($_POST['SecLinks_CSSClass'])));

        $url_loja = stripslashes(get_option('SecLinks_URL'));
        $inuteis_user = stripslashes(get_option('SecLinks_Inuteis'));
        $css_class = stripslashes(get_option('SecLinks_CSSClass'));

        echo "
        <div class='updated'>
            <p>
                <strong>Op&ccedil;&otilde;es Atualizadas!</strong>
            </p>
        </div>";
    };

    echo "
    <div class='wrap'>
        <form name='secLinks' method='post'>
            <h2>Op&ccedil;&otilde;s do Secundum Linkador</h2>

            <fieldset name='def'>
                <label for='SecLinks_URL'>URL da Loja:</label>
                <input type='text' name='SecLinks_URL' id='SecLinks_URL' size='60' maxlength='60' value='$url_loja' />
                <br /><br />
                <label for='SecLinks_CSSClass'>Nome da Classe CSS dos links:</label>
                <input type='text' name='SecLinks_CSSClass' id=' SecLinks_CSSClass' size='30' maxlength='30' value='$css_class' />
                <br /><br />
                <label for='SecLinks_Inuteis'>Palavras In&uacute;teis:</label>
                <textarea name='SecLinks_Inuteis' cols='75' rows='10'>$inuteis_user</textarea>
            </fieldset>
            <div class='submit'>
                <input type='submit' name='info_update' value='Salvar Informa&ccedil;&otilde;es' />
            </div>
        </form>
    </div>
    ";
};

function SecLinksAdmMenu()
{
    if (function_exists('add_options_page'))
        add_options_page('Options', 'Secundum Linkador', 5, basename(__FILE__), 'SecLink_SubPanel');

};



    function secundum_store($texto)
    {
        global $url_loja, $css_class;
        $itens = Array();

        if(is_single()||is_feed())
        {
            $itens = secundum_links($texto);

            for($conta=0;$conta<sizeof($itens);$conta++)
            {
                $itens[$conta] = trim($itens[$conta]);
                $link_loja = "<a href='".$url_loja.str_replace(" ","_",$itens[$conta])."/' class='$css_class'>".$itens[$conta]."</a>";

                $texto = str_replace_count(" {$itens[$conta]} "," {$link_loja} ",$texto,1);
            }
        }

    return $texto;

    }

    function secundum_links($texticulo)
    {
        global $artigos_sec,$inuteis_sec,$inuteis_user;
        $inu = split(',',$inuteis_user);

        foreach ($inu as $palavra)
        {
            $inuteis_sec[] = trim($palavra);
        }

        $texticulo = preg_replace("/(<[\s+]?a.*\/[\s+]?a[\s+]?>)/U", " ", $texticulo);
        $texticulo = preg_replace("/(<[\s+]?script.*\/[\s+]?script[\s+]?>)/U", " ", $texticulo);
        $texticulo = strip_tags($texticulo);
        $texticulo = ereg_replace("[\"\',.;:?!-]","",$texticulo);
        $texticulo = html_entity_decode($texticulo);
        $texticulo = htmlentities($texticulo);

        $substantivos = Array();

        $ac = 0;
        $pal_tmp = explode(" ",$texticulo);
        
        $sec_limite = 0;
        $limitador = 6;

        for($ax=0;$ax<sizeof($pal_tmp);$ax++)
        {
            if(in_array($pal_tmp[$ax],$artigos_sec))
            {
                $termo_tmp = $pal_tmp[$ax+1];
                if(!in_array($termo_tmp,$substantivos) && !in_array($pal_tmp[$ax+1],$artigos_sec) && !in_array($pal_tmp[$ax+1],$inuteis_sec) && e_verbo($pal_tmp[$ax+1]) === FALSE)
                {
                    $ac++;
                    $substantivos[$ac] = $termo_tmp;
                    $sec_limite++;
                }

                $termo_tmp = $pal_tmp[$ax+1] . " " .$pal_tmp[$ax+2];
                if(!in_array($termo_tmp,$substantivos) && !in_array($pal_tmp[$ax+1],$artigos_sec) && !in_array($pal_tmp[$ax+1],$inuteis_sec) && e_verbo($pal_tmp[$ax+1]) === FALSE && !in_array($pal_tmp[$ax+2],$artigos_sec) && !in_array($pal_tmp[$ax+2],$inuteis_sec)  && e_verbo($pal_tmp[$ax+2]) === FALSE)
                {
                    $ac++;
                    $substantivos[$ac] = $termo_tmp;
                    $sec_limite++;
                }
            }
            
            if($sec_limite == $limitador || $sec_limite > $limitador) { break; }
        }

        return $substantivos;
    }

    function e_verbo($palavra)
    {
        if(substr($palavra,-1,1) == "s")
        { return TRUE; }
        if(substr($palavra,-2,2) == "ar" || substr($palavra,-2,2) == "er" || substr($palavra,-2,2) == "ir" || substr($palavra,-2,2) == "or")
        { return TRUE; }
        if(substr($palavra,-4,4) == "ando" || substr($palavra,-4,4) == "endo" || substr($palavra,-4,4) == "indo" || substr($palavra,-4,4) == "ondo")
        { return TRUE; }
        if(substr($palavra,-4,4) == "asse" || substr($palavra,-4,4) == "esse" || substr($palavra,-4,4) == "isse")
        { return TRUE; }
        if(substr($palavra,-4,4) == "isso")
        { return TRUE; }
        if(substr($palavra,-4,4) == "agem")
        { return TRUE; }
        if(substr($palavra,-4,4) == "eito" || substr($palavra,-4,4) == "eita")
        { return TRUE; }
        if(substr($palavra,-4,4) == "assa" || substr($palavra,-4,4) == "asse" || substr($palavra,-4,4) == "asso")
        { return TRUE; }
        if(substr($palavra,-4,3) == "enh" || substr($palavra,-4,3) == "anh" || substr($palavra,-4,3) == "inh" || substr($palavra,-4,3) == "onh" || substr($palavra,-4,3) == "unh")
        { return TRUE; }
        if(substr($palavra,-4,3) == "ant" || substr($palavra,-4,3) == "ent" || substr($palavra,-4,3) == "int" || substr($palavra,-4,3) == "ont" || substr($palavra,-4,3) == "unt")
        { return TRUE; }
        if(substr($palavra,-5,3) == "ant" || substr($palavra,-5,3) == "ent" || substr($palavra,-5,3) == "int" || substr($palavra,-5,3) == "ont" || substr($palavra,-5,3) == "unt")
        { return TRUE; }
        if(substr($palavra,-4,4) == "armo" || substr($palavra,-4,4) == "ermo" || substr($palavra,-4,4) == "irmo" || substr($palavra,-4,4) == "ormo")
        { return TRUE; }
        if(substr($palavra,-4,4) == "arma" || substr($palavra,-4,4) == "erma" || substr($palavra,-4,4) == "irma" || substr($palavra,-4,4) == "orma")
        { return TRUE; }
        if(substr($palavra,-3,3) == "ado" || substr($palavra,-3,3) == "ido" || substr($palavra,-3,3) == "ade" || substr($palavra,-3,3) == "ide" || substr($palavra,-3,3) == "ida")
        { return TRUE; }
        if(substr($palavra,-3,3) == "ivo" || substr($palavra,-3,3) == "iva")
        { return TRUE; }


        return FALSE;
    }

    function str_replace_count($search,$replace,$subject,$times)
    {
        $subject_original=$subject;
        $len=strlen($search);
        $pos=0;
        for ($i=1;$i<=$times;$i++) {
            $pos=stripos($subject,$search,$pos);
            if($pos!==false) {
                $subject=substr($subject_original,0,$pos);
                $subject.=$replace;
                $subject.=substr($subject_original,$pos+$len);
                $subject_original=$subject;
            } else {
                break;
            }
        }
        return($subject);
    }


    add_filter('the_content','secundum_store');
    add_action('admin_menu', 'SecLinksAdmMenu');

?>